<script setup lang="ts">
import { onMounted, ref } from 'vue';
import axios from 'axios';
import { useManagerStore } from '@/stores/manager';

export interface Customer {
    id: number;
    name: string;
    fax: string;
    telephone: string;
    website: string;
    postalCode: string;
    address: string;
    industry: string;
    type: string;
    bankName: string;
    branchName: string;
    accountNumber: string;
    paymentTerm: string;
    accountHolder: string;
    depositType: string;
    comment: string;
    closingDate: string;
    version: number;
    headcount: number;
    annualRevenue: number;
    creatorId: number;
    modifierId: number;
    createdTime: string;
    modifiedTime: string;
}

const managerState = useManagerStore();
const recentCustomers = ref<Customer[]>([]);
const errorMessage = ref<string | null>(null);
const recentCustomersView = ref<{ name: any; telephone: any; address: any }[]>([]);

async function fetchRecentCustomers(): Promise<void> {
    try {
        const response = await axios.get('http://localhost:8080/api/v1/customers/recent', { withCredentials: true });
        recentCustomers.value = response.data;
        recentCustomersView.value = recentCustomers.value.map(customer => {
            return {
                name: customer.name,
                telephone: customer.telephone,
                address: customer.address,
            };
        });
    } catch (error) {
        errorMessage.value = 'Fetching Recent Customers Failed';
    }
}

async function fetchCurrentManager(): Promise<void> {
    try {
        const response = await axios.get('http://localhost:8080/api/v1/managers/current', { withCredentials: true });
        managerState.setCurrentCustomerManagerId(response.data.id);
        managerState.setCurrentCustomerManagerName(response.data.name);
    } catch (error) {
        errorMessage.value = 'Fetching Current Manager Failed';
    }
}

onMounted(fetchCurrentManager)
onMounted(fetchRecentCustomers)

</script>

<template>
    <div class="customer-portal-component">
        <span class="component-title-text">最近の取引情報</span>
    </div>
    <div class="customer-content-wrapper">
        <div class="portal-button-group">
            <RouterLink to="/customer/create">
                <el-button type="primary" plain size="small" style="margin-right: 10px;">
                    新規
                </el-button>
            </RouterLink>
            <RouterLink to="/customer/show">
                <el-button type="primary" plain size="small">
                    詳細情報
                </el-button>
            </RouterLink>
        </div>
        <el-table :data="recentCustomersView" style="width: 100%">
            <el-table-column prop="name" label="取引先名" width="180" />
            <el-table-column prop="telephone" label="電話" width="180" />
            <el-table-column prop="address" label="住所" />
        </el-table>
    </div>

    <div class="inline-block-component">
        <div class="customer-portal-component">
            <span class="component-title-text">レポート</span>
        </div>
        <div class="customer-content-wrapper">
            <el-link type="primary"> <span class="link-text">取引先・得意先一覧</span></el-link>
            <el-link type="primary"> <span class="link-text">取引先・パートナー一覧</span></el-link>
            <el-link type="primary"> <span class="link-text">取引先所有者一覧画面</span></el-link>
            <br />
        </div>
    </div>
    <div class="inline-block-component">
        <div class="customer-portal-component">
            <span class="component-title-text">ツール</span>
        </div>
        <div class="customer-content-wrapper">
            <el-link type="primary"> <span class="link-text">取引先のインポート</span></el-link>
            <el-link type="primary"> <span class="link-text">取引先のエクスポート</span></el-link>
            <el-link type="primary"> <span class="link-text">取引先所有権の移行</span></el-link>
            <br />
        </div>
    </div>
</template>

<style>
.customer-portal-component {
    background-color: hsl(213, 46%, 91%) !important;
    border: 2px solid hsl(213, 42%, 38%) !important;
    width: 100% !important;
}

.customer-content-wrapper {
    border: 2px solid hsl(213, 42%, 38%) !important;
    width: 100% !important;
    border-top: none !important;
    margin-bottom: 20px;
}

.inline-block-component {
    display: inline-block;
    width: 45%;
}

.inline-block-component:last-child {
    display: inline-block;
    margin-left: 75px;
}

.portal-button-group {
    margin: 0px 340px !important;
}

.el-link {
    margin-left: 8px;
    display: block;
}

.component-title-text {
    font-weight: bold !important;
    margin-left: 8px;
}

.link-text {
    text-decoration: underline;
    font-size: 12px;
}
</style>